/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.PerfConfigurationRecord;

import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class PerfConfiguration extends TableImpl<PerfConfigurationRecord> {

    private static final long serialVersionUID = -1810084728;

    /**
     * The reference instance of <code>PERF_CONFIGURATION</code>
     */
    public static final PerfConfiguration PERF_CONFIGURATION = new PerfConfiguration();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<PerfConfigurationRecord> getRecordType() {
        return PerfConfigurationRecord.class;
    }

    /**
     * The column <code>PERF_CONFIGURATION.CONFIGURATION_ID</code>.
     */
    public final TableField<PerfConfigurationRecord, Integer> CONFIGURATION_ID = createField("CONFIGURATION_ID", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>PERF_CONFIGURATION.ACTIVE</code>.
     */
    public final TableField<PerfConfigurationRecord, Byte> ACTIVE = createField("ACTIVE", org.jooq.impl.SQLDataType.TINYINT, this, "");

    /**
     * The column <code>PERF_CONFIGURATION.CREATED</code>.
     */
    public final TableField<PerfConfigurationRecord, Timestamp> CREATED = createField("CREATED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>PERF_CONFIGURATION.CREATED_BY</code>.
     */
    public final TableField<PerfConfigurationRecord, String> CREATED_BY = createField("CREATED_BY", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_CONFIGURATION.DOMAIN</code>.
     */
    public final TableField<PerfConfigurationRecord, String> DOMAIN = createField("DOMAIN", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_CONFIGURATION.EDITED_BY</code>.
     */
    public final TableField<PerfConfigurationRecord, String> EDITED_BY = createField("EDITED_BY", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_CONFIGURATION.CONF_KEY</code>.
     */
    public final TableField<PerfConfigurationRecord, String> CONF_KEY = createField("CONF_KEY", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_CONFIGURATION.CONF_LABEL</code>.
     */
    public final TableField<PerfConfigurationRecord, String> CONF_LABEL = createField("CONF_LABEL", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>PERF_CONFIGURATION.MODIFIED</code>.
     */
    public final TableField<PerfConfigurationRecord, Timestamp> MODIFIED = createField("MODIFIED", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>PERF_CONFIGURATION.TOP_LEVEL</code>.
     */
    public final TableField<PerfConfigurationRecord, Byte> TOP_LEVEL = createField("TOP_LEVEL", org.jooq.impl.SQLDataType.TINYINT, this, "");

    /**
     * The column <code>PERF_CONFIGURATION.VALID_FROM</code>.
     */
    public final TableField<PerfConfigurationRecord, Timestamp> VALID_FROM = createField("VALID_FROM", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * The column <code>PERF_CONFIGURATION.VALID_TO</code>.
     */
    public final TableField<PerfConfigurationRecord, Timestamp> VALID_TO = createField("VALID_TO", org.jooq.impl.SQLDataType.TIMESTAMP, this, "");

    /**
     * Create a <code>PERF_CONFIGURATION</code> table reference
     */
    public PerfConfiguration() {
        this(DSL.name("PERF_CONFIGURATION"), null);
    }

    /**
     * Create an aliased <code>PERF_CONFIGURATION</code> table reference
     */
    public PerfConfiguration(String alias) {
        this(DSL.name(alias), PERF_CONFIGURATION);
    }

    /**
     * Create an aliased <code>PERF_CONFIGURATION</code> table reference
     */
    public PerfConfiguration(Name alias) {
        this(alias, PERF_CONFIGURATION);
    }

    private PerfConfiguration(Name alias, Table<PerfConfigurationRecord> aliased) {
        this(alias, aliased, null);
    }

    private PerfConfiguration(Name alias, Table<PerfConfigurationRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> PerfConfiguration(Table<O> child, ForeignKey<O, PerfConfigurationRecord> key) {
        super(child, key, PERF_CONFIGURATION);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.PERF_CONFIGURATION_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<PerfConfigurationRecord, Integer> getIdentity() {
        return Keys.IDENTITY_PERF_CONFIGURATION;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<PerfConfigurationRecord> getPrimaryKey() {
        return Keys.KEY_PERF_CONFIGURATION_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<PerfConfigurationRecord>> getKeys() {
        return Arrays.<UniqueKey<PerfConfigurationRecord>>asList(Keys.KEY_PERF_CONFIGURATION_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PerfConfiguration as(String alias) {
        return new PerfConfiguration(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public PerfConfiguration as(Name alias) {
        return new PerfConfiguration(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public PerfConfiguration rename(String name) {
        return new PerfConfiguration(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public PerfConfiguration rename(Name name) {
        return new PerfConfiguration(name, null);
    }
}
